'use strict';

Object.defineProperty(exports, "__esModule", {
   value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormField = require('./FormField');

var _FormField2 = _interopRequireDefault(_FormField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var Form = {};

Form.Component = function (_ref) {
   var id = _ref.id,
       name = _ref.name,
       onSubmit = _ref.onSubmit,
       children = _ref.children;
   return _react2.default.createElement(
      'form',
      {
         id: id,
         name: name,
         onSubmit: onSubmit
      },
      children
   );
};

Form.Component.propTypes = {
   id: _propTypes2.default.string,
   name: _propTypes2.default.string,
   onSubmit: _propTypes2.default.func
};

Form.Field = _FormField2.default;

Form.customValidityFactory = function (constraint) {
   var validationMessage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'Invalid';
   return function () {
      return constraint.apply(undefined, arguments) ? '' : validationMessage;
   };
};

Form.fields = function () {
   var globalProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
   var fields = arguments[1];
   return Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.entries(fields).map(function (_ref2) {
      var _ref3 = _slicedToArray(_ref2, 2),
          fieldKey = _ref3[0],
          field = _ref3[1];

      return _defineProperty({}, fieldKey, _extends({}, Form.Field.defaultProps, { name: fieldKey }, globalProps, field));
   }))));
};

Form.getData = function (form) {
   return Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.entries(Form.getProps(form).fields).filter(function (_ref5) {
      var _ref6 = _slicedToArray(_ref5, 2),
          fieldKey = _ref6[0],
          field = _ref6[1];

      return !field.disabled;
   }).filter(function (_ref7) {
      var _ref8 = _slicedToArray(_ref7, 2),
          fieldKey = _ref8[0],
          field = _ref8[1];

      return !['checkbox', 'radio'].includes(field.type) || field.checked;
   }).map(function (_ref9) {
      var _ref10 = _slicedToArray(_ref9, 2),
          fieldKey = _ref10[0],
          field = _ref10[1];

      return _defineProperty({}, fieldKey, field.value);
   }))));
};

Form.getProps = function (form) {
   return Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.entries(form).filter(function (_ref12) {
      var _ref13 = _slicedToArray(_ref12, 2),
          formPropKey = _ref13[0],
          formProp = _ref13[1];

      return formPropKey !== 'fields';
   }).map(function (_ref14) {
      var _ref15 = _slicedToArray(_ref14, 2),
          formPropKey = _ref15[0],
          formProp = _ref15[1];

      return _defineProperty({}, formPropKey, formProp instanceof Function ? formProp(form) : formProp);
   })), [{
      fields: Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.entries(form.fields).map(function (_ref17) {
         var _ref18 = _slicedToArray(_ref17, 2),
             fieldKey = _ref18[0],
             field = _ref18[1];

         return _defineProperty({}, fieldKey, Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.entries(field).map(function (_ref19) {
            var _ref20 = _slicedToArray(_ref19, 2),
                fieldPropKey = _ref20[0],
                fieldProp = _ref20[1];

            return _defineProperty({}, fieldPropKey, fieldProp instanceof Function ? fieldProp(form, fieldKey) : fieldProp);
         })))));
      }))))
   }]));
};

Form.onChangeFactory = function (fn) {
   return function (form, fieldKey) {
      return function (updatedProps) {
         return fn(_extends({}, form, {
            fields: _extends({}, form.fields, _defineProperty({}, fieldKey, _extends({}, form.fields[fieldKey], updatedProps)))
         }));
      };
   };
};

Form.onSubmitFactory = function (fn) {
   return function (form) {
      return function (ev) {
         ev.preventDefault();
         fn(Form.getData(form));
      };
   };
};

exports.default = Form;